////////////////////////////////////////////////
// グローバル変数 
////////////////////////////////////////////////
// 状態管理  
var gStartedState =false;					// スライドショーが開始されたかどうか（OnLoad()/OnShow()が同時に走らないように。念のため。） 

// コントロール（みたいな） 
var gFront = null;							// 表 
var gInfoButton = null;						// 表 - Infoボタン 
var gImageCanvas1 = null;					// 表 - キャンパス  
var gBack = null;							// 環境設定 
var gDoneButton = null;						// 環境設定 - Doneボタン 
var gSlideIntervalText = null;				// 環境設定 - インターバル   
var gSizeWinWidthText = null;				// 環境設定 - 幅   
var gSizeWinHeightText = null;				// 環境設定 - 高さ   

// イメージ配列 
var gImageAry = null;						// スライド対象の画像の配列 
var gImageNum = 12;							// スライド対象の画像の数（環境設定の値と連動） 
var gImageID  = 0;							// 現在、スライドされている画像のgImageAryのインデックス番号 
var gImageCounter = 0;						// どの画像を表示するかどうかを決定する為の内部的なカウンター 
var	gLoadImage_OK = false;					// gImageAryが準備出来たかどうかのフラグ 
var	gWaitTimerID = null;					// gImageArygImageAryが準備出来るまで待つタイマーID 

// トランジット関係 
var gDrawImageCanvasTimerID = null;			// トランジッション時に、徐々に表示する為のタイマーID  
var gAlphaValueCounter  = 0.0;				// トランジット時の透明度のカウンター 
var gAlphaValueCounterStep  = 0.1;			// トランジット時の透明度のカウンターのステップ。最終的に、1.0になる値にすること。 

// 表示時間 
var gShowMSecOnePic  = 3000;				// 1枚画像の表示時間 msec （環境設定の値と連動） 

// その他  
var gArcRadius = 10;						// ウインドウの四隅の丸みの半径 
var gCanvasWidth  = 240;					// キャンパスサイズ（幅） （環境設定の値と連動）  
var gCanvasHeight  = 320;					// キャンパスサイズ（高さ）（環境設定の値と連動）  
var gOpen_cmd_path = "/usr/bin/open";		// openコマンドのパス 
var gHelpFileName = "Help.html"				// ヘルプファイル名 
 
////////////////////////////////////////////////
// 外部関数 
////////////////////////////////////////////////
// デバック用 
function DebugStr( inString )
{
	if ( window.widget )
	{
		alert( inString );
	}

	var theDebug = document.getElementById( "ID_Debug" );
	theDebug.appendChild( document.createTextNode( inString ) );
	theDebug.appendChild( document.createElement( "br" ) );
	theDebug.scrollTop = theDebug.scrollHeight;
}

// イベント 
function OnBodyLoaded()
{
	// コントロール 
	gImageCanvas1 = document.getElementById( "ID_ImageCanvas1" );
	gSlideIntervalText = document.getElementById( "ID_SlideIntervalText" );
	gSizeWinWidthText = document.getElementById( "ID_SizeWinWidthText" );
	gSizeWinHeightText = document.getElementById( "ID_SizeWinHeightText" );
	gFront = document.getElementById("ID_Front");
	gBack = document.getElementById("ID_Back");
	gDoneButton = new AppleGlassButton( document.getElementById("ID_DoneButton"), "Done", z_HidePref );
	gInfoButton = new AppleInfoButton( document.getElementById("ID_InfoButton"), gFront, "white", "white", z_ShowPref );
	
	// ローカライズ 
	var theLocalizeTarget;
	
	theLocalizeTarget = document.getElementById( "ID_SlideIntervalTitle" );
	theLocalizeTarget.innerText = string_SlideInterval;
	theLocalizeTarget = document.getElementById( "ID_Sec" );
	theLocalizeTarget.innerText = string_Sec;
	theLocalizeTarget = document.getElementById( "ID_SizeWinWidthTitle" );
	theLocalizeTarget.innerText = string_WinSizeWidth;
	theLocalizeTarget = document.getElementById( "ID_Px1" );
	theLocalizeTarget.innerText = string_Pixel;
	theLocalizeTarget = document.getElementById( "ID_SizeWinHeightTitle" );
	theLocalizeTarget.innerText = string_WinSizeHeight;
	theLocalizeTarget = document.getElementById( "ID_Px2" );
	theLocalizeTarget.innerText = string_Pixel;
	theLocalizeTarget = document.getElementById( "ID_ReplacePicturesTitle" );
	theLocalizeTarget.innerText = string_ReplacePictures;
	theLocalizeTarget = document.getElementById( "ID_SeeHelpButton" );
	theLocalizeTarget.value = string_SeeHelp;

	// タイミングによってうまくいかない場合があるみたいなので、タイマーでスライドショーを開始する。 
	setTimeout( "z_InitTimerOnLoadedProc();", 500 );
}

// ヘルプ表示 
function OnShowHelp()
{
	widget.system( gOpen_cmd_path + " " + gHelpFileName, null );
}

////////////////////////////////////////////////
// 内部関数 
////////////////////////////////////////////////
// 環境設定  
function z_ReadPref()
{
	if ( window.widget )
	{
		var tempSlideInterval = widget.preferenceForKey( "Key_SlideInterval" );
		if ( null != tempSlideInterval && 0 != tempSlideInterval )
		{
			gShowMSecOnePic = tempSlideInterval * 1000;
		}

		var tempSizeWinWidth = widget.preferenceForKey( "Key_SizeWinWidth" );
		if ( null != tempSizeWinWidth && 100 <= tempSizeWinWidth )
		{
			gCanvasWidth = tempSizeWinWidth;
		}
		
		var tempSizeWinHeight = widget.preferenceForKey( "Key_SizeWinHeight" );
		if ( null != tempSizeWinHeight && 100 <= tempSizeWinHeight )
		{
			gCanvasHeight = tempSizeWinHeight;
		}
		

	}
}

function z_WritePref()
{
	if ( window.widget )
	{
		widget.setPreferenceForKey( gShowMSecOnePic / 1000, "Key_SlideInterval" );
		widget.setPreferenceForKey( gCanvasWidth, "Key_SizeWinWidth" );
		widget.setPreferenceForKey( gCanvasHeight, "Key_SizeWinHeight" );
	}
}

function z_ShowPref()
{
	resizeTo( 320, 320 );

	OnHideWidget();

	gSlideIntervalText.value = gShowMSecOnePic / 1000;
	gSizeWinWidthText.value = gCanvasWidth;
	gSizeWinHeightText.value = gCanvasHeight;
	
	if ( window.widget )
	{
		widget.prepareForTransition( "ToBack" );
	}
	
	gFront.style.display = "none";
	gBack.style.display = "block";
	
	if ( window.widget )
	{
		setTimeout( 'widget.performTransition();', 0 );
	}
}

function z_HidePref()
{
	gShowMSecOnePic = gSlideIntervalText.value * 1000;
	if ( 0 == gShowMSecOnePic )
	{
		gShowMSecOnePic = 1000;
	}

	gCanvasWidth = gSizeWinWidthText.value;
	if ( gCanvasWidth < 100 )
	{
		gCanvasWidth = 100;
	}

	gCanvasHeight = gSizeWinHeightText.value;
	if ( gCanvasHeight < 100 )
	{
		gCanvasHeight = 100;
	}

	z_WritePref();

	if ( window.widget )
	{
		widget.prepareForTransition("ToFront");
	}
	
	gBack.style.display = "none";
	gFront.style.display = "block";
	
	if ( window.widget )
	{
		setTimeout( 'widget.performTransition();', 0 );
	}

	OnShowWidget();
}

// Widgetのイベント 
function OnShowWidget()
{
	if ( false == gStartedState )
	{
		gStartedState = true;
		z_ReadPref();
		z_Init();
		z_StartDrawImageCanvas();
		resizeTo( gCanvasWidth, gCanvasHeight );
	}
}

function OnHideWidget()
{
	clearTimeout( gWaitTimerID );
	gWaitTimerID = null;
	clearTimeout( gDrawImageCanvasTimerID );
	gDrawImageCanvasTimerID = null;
	gStartedState = false;
	z_WritePref();
}

// 初期化 
function z_Init()
{
	var	ret = true;
	var path;
	var temp = "temp";

	gImageID  = 0;
	gImageCounter = 0;
	clearTimeout( gWaitTimerID );
	gWaitTimerID = null;
	clearTimeout( gDrawImageCanvasTimerID );
	gDrawImageCanvasTimerID = null;
	gLoadImage_OK = false;
	gAlphaValueCounter  = 0.0;

	z_Make_gImageAry();

	return ret;
}

// 画像の読み込みチェック 
function z_ChaeckLoadImage( inImageNum )
{
	var ret = false;

	if ( false == gLoadImage_OK )
	{
		for ( i = 0; i < inImageNum; i++ )
		{
			if ( gImageAry[i].complete != true )
			{
				return false;
			}
		}
	}
	
	gLoadImage_OK = true;
	
	return true;
}

// 四隅の描画 
function z_DrawImageCorner()
{
	var context = gImageCanvas1.getContext( "2d" );

	context.save();

	context.globalCompositeOperation = "copy";
	context.fillStyle = "rgba( 255, 255, 255, 0.0 )";
	
	// 左上 
	context.beginPath();
	context.moveTo( 0, gArcRadius );
	context.arc( gArcRadius, gArcRadius, gArcRadius, Math.PI, Math.PI + Math.PI / 2, 0 );
	context.lineTo( 0, 0 );
	context.lineTo( 0, gArcRadius );
	context.closePath();
	context.fill();
	// 右上 
	context.beginPath();
	context.moveTo( gCanvasWidth - gArcRadius, 0 );
	context.arc( gCanvasWidth - gArcRadius, gArcRadius, gArcRadius, Math.PI + Math.PI / 2, 0, 0 );
	context.lineTo( gCanvasWidth, 0 );
	context.lineTo( gCanvasWidth - gArcRadius, 0 );
	context.closePath();
	context.fill();
	// 右下 
	context.beginPath();
	context.moveTo( gCanvasWidth, gCanvasHeight - gArcRadius );
	context.arc( gCanvasWidth - gArcRadius, gCanvasHeight - gArcRadius, gArcRadius, 0, Math.PI / 2, 0 );
	context.lineTo( gCanvasWidth, gCanvasHeight );
	context.lineTo( gCanvasWidth, gCanvasHeight - gArcRadius );
	context.closePath();
	context.fill();
	// 左下 
	context.beginPath();
	context.moveTo( 0, gCanvasHeight - gArcRadius );
	context.arc( gArcRadius, gCanvasHeight - gArcRadius, gArcRadius, Math.PI, Math.PI / 2, 1 );
	context.lineTo( 0, gCanvasHeight );
	context.lineTo( 0, gCanvasHeight - gArcRadius );
	context.closePath();
	context.fill();
	
	context.restore();
}

// トランジッション 
function z_DrawImageTransitionByAlpha()
{
	var context = gImageCanvas1.getContext( "2d" );
	gAlphaValueCounter += gAlphaValueCounterStep;

	context.globalAlpha = gAlphaValueCounter;
	context.drawImage( gImageAry[ gImageID ], 0, 0, gCanvasWidth, gCanvasHeight );
	
	if ( gAlphaValueCounter < 1.0 )
	{
		setTimeout( "z_DrawImageTransitionByAlpha( gImageID );", 50 );
	}
	else
	{
		gAlphaValueCounter = 0.0;
	}
	
	z_DrawImageCorner();
}

// 描画 
function z_DrawImageCanvas()
{
	gImageID = gImageCounter % gImageNum;
	
	z_DrawImageTransitionByAlpha( gImageID );

	gImageCounter++;

	if ( gImageNum == gImageCounter )
	{
		gImageCounter = 0;
	}
	
	gFront.style.background = "rgba( 0, 0, 0, 0.0 )";
	gDrawImageCanvasTimerID = setTimeout( "z_DrawImageCanvas();", gShowMSecOnePic );
}

// 描画の開始 
function z_StartDrawImageCanvas()
{
	gFront.style.background = "#000000";
	if ( false == z_ChaeckLoadImage( gImageNum ) )
	{
		gWaitTimerID = setTimeout( "z_StartDrawImageCanvas();", 100 );
		return;
	}

	z_DrawImageCanvas();
}

// Widgetの開始 
function z_InitTimerOnLoadedProc()
{
	if ( window.widget )
	{
		widget.onshow = OnShowWidget;
		widget.onhide = OnHideWidget;
	}
	
	OnShowWidget();
}

// イメージアレイの作成 
function z_Make_gImageAry()
{
	var theOutputls = widget.system( "/bin/ls -m ./Pic_v100/*.jpg", null ).outputString;
	var theLen = theOutputls.length;
	var the1stStr = "./Pic_v100/";
	var the2ndStr = ".jpg,";
	var the1stLen = the1stStr.length;
	var the2ndLen = the2ndStr.length;
	var theWalker1 = 0;
	var theWalker2 = 0;
	var thePath;
	var theImage;

	gImageNum = 0;
	gImageAry =  new Array();

	while ( theWalker1 <= theLen )
	{
		theWalker1 = theOutputls.indexOf( the1stStr, theWalker1 );
		theWalker2 = theOutputls.indexOf( the2ndStr, theWalker2 );
		if ( -1 == theWalker1 || -1 == theWalker2 )
		{
			break;
		}
		else
		{
			if ( theWalker1 < theWalker2 )
			{
				thePath = theOutputls.substring( theWalker1, theWalker2 + the2ndLen  - 1 );
				theImage = new Image( 320, 320 );
				theImage.src = thePath;
				gImageAry.push( theImage );
				gImageNum++;
			}
		}
		
		theWalker2 += the2ndLen;
		theWalker1 = theWalker2;
	}
}

